@section('requests_history_src')
source {{ $index_prefix }}requests_history_src
{
@yield('connection')

    sql_query_range     = SELECT MIN({{ $xrequesthistory }}), MAX({{ $xrequesthistory }}) FROM {{ $hs_request_history }}
    sql_range_step      = 5000

    sql_query           = \
    SELECT {{ $xrequesthistory }}*10+2 as id, {{ $hs_request_history }}.{{ $xrequest }}, {{ $hs_request_history }}.{{ $xrequesthistory }}, {{ $hs_request }}.{{ $xcategory }}, \
    '' as {{ $stitle }}, '' as {{ $sfirstname }}, '' as {{ $slastname }}, '' as {{ $semail }}, '' as {{ $sphone }}, '' as {{ $suserid }},  {{ $xpersonassignedto }}, \
    {{ $dtgmtchange }} as created_at, \
    {{ $custom_fields }} \
    {{ $tnote }} \
    FROM {{ $hs_request_history }} \
    JOIN {{ $hs_request }} ON {{ $hs_request_history }}.{{ $xrequest }} = {{ $hs_request }}.{{ $xrequest }} \
    WHERE {{ $xrequesthistory }} >= $start AND {{ $xrequesthistory }} <= $end \
    AND {{ $tnote }} != ''

    sql_attr_uint       = xRequest
    sql_attr_uint       = xRequestHistory
    sql_attr_uint       = xCategory
    sql_attr_uint       = xPersonAssignedTo
    sql_attr_timestamp  = created_at

    sql_ranged_throttle = 0

    @foreach($post_query as $query)
sql_query_post_index       = {{ $query }}

    @endforeach
}

source {{ $index_prefix }}requests_history_src_delta : {{ $index_prefix }}requests_history_src
{
    sql_query_range     = {{ $delta_range }}
    sql_range_step      = 5000

    sql_query           = \
    SELECT {{ $xrequesthistory }}*10+2 as id, {{ $hs_request_history }}.{{ $xrequest }}, {{ $hs_request_history }}.{{ $xrequesthistory }}, {{ $hs_request }}.{{ $xcategory }}, \
    '' as {{ $stitle }}, '' as {{ $sfirstname }}, '' as {{ $slastname }}, '' as {{ $semail }}, '' as {{ $sphone }}, '' as {{ $suserid }},  {{ $xpersonassignedto }}, \
    {{ $dtgmtchange }} as created_at, \
    {{ $custom_fields }} \
    {{ $tnote }} \
    FROM {{ $hs_request_history }} \
    JOIN {{ $hs_request }} ON {{ $hs_request_history }}.{{ $xrequest }} = {{ $hs_request }}.{{ $xrequest }} \
    WHERE {{ $xrequesthistory }} > $start AND {{ $xrequesthistory }} <= $end \
    AND {{ $tnote }} != ''
}
@stop