<?php
// SECURITY: Don't allow direct calls
if (!defined('cBASEPATH')) die();

/*****************************************
CLEAN SQL FOR POSTGRES. 
*****************************************/
function hsQueryReWrite(&$db, &$sql, &$inputarray){
	$db->hsQueryReWrite($sql);
}
/****************************************/

include_once(ADODB_DIR."/drivers/adodb-postgres64.inc.php");
include_once(ADODB_DIR."/drivers/adodb-postgres7.inc.php");

class ADODB_postgres_helpspot extends ADODB_postgres7 {

	var $metaColumnsSQL = "
				SELECT
					a.attname, t.typname as type, a.attlen, a.atttypmod, a.attnotnull, a.atthasdef, -1 AS attstattarget, a.attstorage,
					(SELECT adsrc FROM pg_attrdef adef WHERE a.attrelid=adef.adrelid AND a.attnum=adef.adnum) AS adsrc,
					a.attstorage AS typstorage, false AS attisserial
				FROM
					pg_attribute a,
					pg_class c,
					pg_type t
				WHERE
					c.relname = '%s' AND a.attnum > 0 AND a.attrelid = c.oid AND a.atttypid = t.oid
				ORDER BY a.attnum";

	var $fnExecute = 'hsQueryReWrite';

	/*****************************************
	OVERRIDE SO THAT QUERY REWRITE CAN BE TURNED OFF
	*****************************************/	
	function MetaColumns($table,$normalize=false){
		$GLOBALS['BYPASS_SQLFILTER'] = true; //meta columms doesn't need quotes.
		
		//$rs = parent::MetaColumns($table,$normalize);
		//$rs = $this->Execute(sprintf($this->metaColumnsSQL,$table));
		$rs =& ADOConnection::MetaColumns($table,false);
		
		unset($GLOBALS['BYPASS_SQLFILTER']);
	
		return $rs;
	}
	
	/*****************************************
	OVERRIDE SO THAT QUERY REWRITE CAN BE TURNED OFF
	*****************************************/	
	function MetaTables(){
		$GLOBALS['BYPASS_SQLFILTER'] = true; //meta columms doesn't need quotes.
		
		$this->metaTablesSQL = "select tablename,'T' from pg_tables where tablename not like 'pg\_%'
								and schemaname  not in ( 'pg_catalog','information_schema')
								union
								select viewname,'V' from pg_views where viewname not like 'pg\_%'  and schemaname  not in ( 'pg_catalog','information_schema') ";
		
		$rs =& ADOConnection::MetaTables('TABLE',false);
		
		unset($GLOBALS['BYPASS_SQLFILTER']);
	
		return $rs;
	}	
	
	/*****************************************
	OVERRIDE SO WE CAN QUOTE SEQ
	*****************************************/		
	function pg_insert_id($tablename,$fieldname)
	{
		$result=pg_exec($this->_connectionID, "SELECT last_value FROM \"${tablename}_${fieldname}_seq\"");
		if ($result) {
			$arr = @pg_fetch_row($result,0);
			pg_freeresult($result);
			if (isset($arr[0])) return $arr[0];
		}
		return false;
	}	
	
	/*****************************************
	OVERRIDE SO WE CAN BYPASS hsQueryReWrite
	*****************************************/	
	//updating large blobs takes too long to go through hsQueryReWrite so we manually do the quotes here
	//and call the parent function to do the blob insert
	function UpdateBlob($table,$column,$val,$where)
	{	
		$this->hsQueryReWrite($where); //use hsQueryReWrite to escape anything in the where clause
		
		$GLOBALS['BYPASS_SQLFILTER'] = true; //We don't want the update to be parsed by hsQueryReWrite
		
		$rs = parent::UpdateBlob('"'.$table.'"','"'.$column.'"',$val,$where);

		unset($GLOBALS['BYPASS_SQLFILTER']);
		
		//Return results of update, needed in add doc functions
		return $rs;
	}		
	
	/*****************************************
	FIX QUERIES FOR POSTGRES. REWRITE THEM
	TO BE LOWERCASE
	*****************************************/
	function hsQueryReWrite(&$sql){
	
		if(!isset($GLOBALS['BYPASS_SQLFILTER'])){
		
			if(!isset($GLOBALS['HSDB'])){
				//Special to handle customs
				$GLOBALS['HSDB']['@(\W)Custom([0-9]{1,3})(\W)@'] = '$1"Custom$2"$3';
					
				//All other fields and tables
				//NOTE YOU CAN NEVER REMOVE ANY FROM HERE OR INSTALLER.PHP WON'T WORK WHEN UPDATING
				$GLOBALS['HSDB']['@(\W)HS_Portal_Bayesian_MsgCounts(\W)@'] = '$1"HS_Portal_Bayesian_MsgCounts"$2';	//28
				$GLOBALS['HSDB']['@(\W)HS_Portal_Bayesian_Corpus(\W)@'] = '$1"HS_Portal_Bayesian_Corpus"$2';	//25
				$GLOBALS['HSDB']['@(\W)HS_Category_ReportingTags(\W)@'] = '$1"HS_Category_ReportingTags"$2';	
				$GLOBALS['HSDB']['@(\W)HS_Request_ReportingTags(\W)@'] = '$1"HS_Request_ReportingTags"$2';	//24
				$GLOBALS['HSDB']['@(\W)HS_Mailboxes_StuckEmails(\W)@'] = '$1"HS_Mailboxes_StuckEmails"$2';
				$GLOBALS['HSDB']['@(\W)HS_Request_Note_Drafts(\W)@'] = '$1"HS_Request_Note_Drafts"$2';	//22
				$GLOBALS['HSDB']['@(\W)fLimitedToAssignedCats(\W)@'] = '$1"fLimitedToAssignedCats"$2';
				$GLOBALS['HSDB']['@(\W)fSidebarSearchFullText(\W)@'] = '$1"fSidebarSearchFullText"$2';
				$GLOBALS['HSDB']['@(\W)HS_Bayesian_MsgCounts(\W)@'] = '$1"HS_Bayesian_MsgCounts"$2';	//21 
				$GLOBALS['HSDB']['@(\W)HS_Documents_Location(\W)@'] = '$1"HS_Documents_Location"$2';
				$GLOBALS['HSDB']['@(\W)HS_Filter_Performance(\W)@'] = '$1"HS_Filter_Performance"$2';
				$GLOBALS['HSDB']['@(\W)fCustomerFriendlyRSS(\W)@'] = '$1"fCustomerFriendlyRSS"$2';	//20
				$GLOBALS['HSDB']['@(\W)HS_Forums_KnownUsers(\W)@'] = '$1"HS_Forums_KnownUsers"$2';
				$GLOBALS['HSDB']['@(\W)iRequestHistoryLimit(\W)@'] = '$1"iRequestHistoryLimit"$2';
				$GLOBALS['HSDB']['@(\W)sLastImportMessageId(\W)@'] = '$1"sLastImportMessageId"$2';
				$GLOBALS['HSDB']['@(\W)iLastImportAttemptCt(\W)@'] = '$1"iLastImportAttemptCt"$2';
				$GLOBALS['HSDB']['@(\W)HS_Permission_Groups(\W)@'] = '$1"HS_Permission_Groups"$2';
				$GLOBALS['HSDB']['@(\W)HS_Automation_Rules(\W)@'] = '$1"HS_Automation_Rules"$2'; //19 
				$GLOBALS['HSDB']['@(\W)sRequestHistoryHash(\W)@'] = '$1"sRequestHistoryHash"$2';
				$GLOBALS['HSDB']['@(\W)fRequestHistoryView(\W)@'] = '$1"fRequestHistoryView"$2';
				$GLOBALS['HSDB']['@(\W)HS_Assignment_Chain(\W)@'] = '$1"HS_Assignment_Chain"$2';
				$GLOBALS['HSDB']['@(\W)fCanViewOwnReqsOnly(\W)@'] = '$1"fCanViewOwnReqsOnly"$2';
				$GLOBALS['HSDB']['@(\W)HS_Reminder_Person(\W)@'] = '$1"HS_Reminder_Person"$2';	//18
				$GLOBALS['HSDB']['@(\W)fAllowPublicSubmit(\W)@'] = '$1"fAllowPublicSubmit"$2';
				$GLOBALS['HSDB']['@(\W)HS_KB_RelatedPages(\W)@'] = '$1"HS_KB_RelatedPages"$2';
				$GLOBALS['HSDB']['@(\W)HS_Bayesian_Corpus(\W)@'] = '$1"HS_Bayesian_Corpus"$2';
				$GLOBALS['HSDB']['@(\W)xPersonOutOfOffice(\W)@'] = '$1"xPersonOutOfOffice"$2';
				$GLOBALS['HSDB']['@(\W)HS_Request_History(\W)@'] = '$1"HS_Request_History"$2';
				$GLOBALS['HSDB']['@(\W)fKeyboardShortcuts(\W)@'] = '$1"fKeyboardShortcuts"$2';
				$GLOBALS['HSDB']['@(\W)fMergedFromRequest(\W)@'] = '$1"fMergedFromRequest"$2';
				$GLOBALS['HSDB']['@(\W)tAutoResponse_HTML(\W)@'] = '$1"tAutoResponse_HTML"$2'; //keep because it's needed during upgrade for rename sql
				$GLOBALS['HSDB']['@(\W)tAutoResponse_html(\W)@'] = '$1"tAutoResponse_html"$2';
				$GLOBALS['HSDB']['@(\W)HS_Stats_Responses(\W)@'] = '$1"HS_Stats_Responses"$2';
				$GLOBALS['HSDB']['@(\W)xMailboxToSendFrom(\W)@'] = '$1"xMailboxToSendFrom"$2';
				$GLOBALS['HSDB']['@(\W)tDisplayCategories(\W)@'] = '$1"tDisplayCategories"$2';
				$GLOBALS['HSDB']['@(\W)xAssignmentChainId(\W)@'] = '$1"xAssignmentChainId"$2';
				$GLOBALS['HSDB']['@(\W)fCanAdvancedSearch(\W)@'] = '$1"fCanAdvancedSearch"$2';
				$GLOBALS['HSDB']['@(\W)HS_Response_People(\W)@'] = '$1"HS_Response_People"$2';
				$GLOBALS['HSDB']['@(\W)HS_Response_Group(\W)@'] = '$1"HS_Response_Group"$2';
				$GLOBALS['HSDB']['@(\W)fNotifyNewRequest(\W)@'] = '$1"fNotifyNewRequest"$2';	//17
				$GLOBALS['HSDB']['@(\W)xPersonAssignedTo(\W)@'] = '$1"xPersonAssignedTo"$2';
				$GLOBALS['HSDB']['@(\W)sWorkspaceDefault(\W)@'] = '$1"sWorkspaceDefault"$2';	
				$GLOBALS['HSDB']['@(\W)HS_Request_Pushed(\W)@'] = '$1"HS_Request_Pushed"$2';
				$GLOBALS['HSDB']['@(\W)HS_Search_Queries(\W)@'] = '$1"HS_Search_Queries"$2';
				$GLOBALS['HSDB']['@(\W)HS_Request_Merged(\W)@'] = '$1"HS_Request_Merged"$2';
				$GLOBALS['HSDB']['@(\W)sPersonAssignedTo(\W)@'] = '$1"sPersonAssignedTo"$2';
				$GLOBALS['HSDB']['@(\W)tHistoryMailboxes(\W)@'] = '$1"tHistoryMailboxes"$2';
				$GLOBALS['HSDB']['@(\W)fModuleForumsPriv(\W)@'] = '$1"fModuleForumsPriv"$2';
				$GLOBALS['HSDB']['@(\W)xPersonLastUpdate(\W)@'] = '$1"xPersonLastUpdate"$2';
				$GLOBALS['HSDB']['@(\W)HS_Login_Attempts(\W)@'] = '$1"HS_Login_Attempts"$2';
				$GLOBALS['HSDB']['@(\W)HS_Reset_Password(\W)@'] = '$1"HS_Reset_Password"$2';
				$GLOBALS['HSDB']['@(\W)HS_Forums_Topics(\W)@'] = '$1"HS_Forums_Topics"$2';		//16
				$GLOBALS['HSDB']['@(\W)HS_Person_Photos(\W)@'] = '$1"HS_Person_Photos"$2';
				$GLOBALS['HSDB']['@(\W)sRequestPassword(\W)@'] = '$1"sRequestPassword"$2';
				$GLOBALS['HSDB']['@(\W)HS_Subscriptions(\W)@'] = '$1"HS_Subscriptions"$2';
				$GLOBALS['HSDB']['@(\W)fNotifySMSUrgent(\W)@'] = '$1"fNotifySMSUrgent"$2';
				$GLOBALS['HSDB']['@(\W)tResponseOptions(\W)@'] = '$1"tResponseOptions"$2';
				$GLOBALS['HSDB']['@(\W)fDefaultToPublic(\W)@'] = '$1"fDefaultToPublic"$2';
				$GLOBALS['HSDB']['@(\W)fAssignToDefault(\W)@'] = '$1"fAssignToDefault"$2';
				$GLOBALS['HSDB']['@(\W)iSpamProbability(\W)@'] = '$1"iSpamProbability"$2';
				$GLOBALS['HSDB']['@(\W)sCustomFieldList(\W)@'] = '$1"sCustomFieldList"$2';
				$GLOBALS['HSDB']['@(\W)HS_Person_Status(\W)@'] = '$1"HS_Person_Status"$2';
				$GLOBALS['HSDB']['@(\W)xChangedByPerson(\W)@'] = '$1"xChangedByPerson"$2';
				$GLOBALS['HSDB']['@(\W)fCanBatchRespond(\W)@'] = '$1"fCanBatchRespond"$2';
				$GLOBALS['HSDB']['@(\W)fPermissionGroup(\W)@'] = '$1"fPermissionGroup"$2';
				$GLOBALS['HSDB']['@(\W)HS_Filter_People(\W)@'] = '$1"HS_Filter_People"$2';
				$GLOBALS['HSDB']['@(\W)HS_Filter_Group(\W)@'] = '$1"HS_Filter_Group"$2';
				$GLOBALS['HSDB']['@(\W)HS_Saved_Reports(\W)@'] = '$1"HS_Saved_Reports"$2';
				$GLOBALS['HSDB']['@(\W)HS_CustomFields(\W)@'] = '$1"HS_CustomFields"$2';		//15
				$GLOBALS['HSDB']['@(\W)xPersonOpenedBy(\W)@'] = '$1"xPersonOpenedBy"$2';
				$GLOBALS['HSDB']['@(\W)xRequestHistory(\W)@'] = '$1"xRequestHistory"$2';
				$GLOBALS['HSDB']['@(\W)HS_Forums_Posts(\W)@'] = '$1"HS_Forums_Posts"$2';
				$GLOBALS['HSDB']['@(\W)HS_KB_Documents(\W)@'] = '$1"HS_KB_Documents"$2';
				$GLOBALS['HSDB']['@(\W)HS_Time_Tracker(\W)@'] = '$1"HS_Time_Tracker"$2';
				$GLOBALS['HSDB']['@(\W)tSignature_HTML(\W)@'] = '$1"tSignature_HTML"$2';
				$GLOBALS['HSDB']['@(\W)isAlwaysVisible(\W)@'] = '$1"isAlwaysVisible"$2';
				$GLOBALS['HSDB']['@(\W)HS_Portal_Login(\W)@'] = '$1"HS_Portal_Login"$2';
				$GLOBALS['HSDB']['@(\W)sEmailMessageId(\W)@'] = '$1"sEmailMessageId"$2';
				$GLOBALS['HSDB']['@(\W)sLastImportFrom(\W)@'] = '$1"sLastImportFrom"$2';
				$GLOBALS['HSDB']['@(\W)dtCachedCountAt(\W)@'] = '$1"dtCachedCountAt"$2';
				$GLOBALS['HSDB']['@(\W)HS_Multi_Portal(\W)@'] = '$1"HS_Multi_Portal"$2';
				$GLOBALS['HSDB']['@(\W)xPreviousPerson(\W)@'] = '$1"xPreviousPerson"$2';
				$GLOBALS['HSDB']['@(\W)HS_Address_Book(\W)@'] = '$1"HS_Address_Book"$2';
				$GLOBALS['HSDB']['@(\W)fCanManageTrash(\W)@'] = '$1"fCanManageTrash"$2';
				$GLOBALS['HSDB']['@(\W)fCanManageForum(\W)@'] = '$1"fCanManageForum"$2';
				$GLOBALS['HSDB']['@(\W)HS_Cache_Static(\W)@'] = '$1"HS_Cache_Static"$2';
				$GLOBALS['HSDB']['@(\W)HS_KB_Chapters(\W)@'] = '$1"HS_KB_Chapters"$2';			//14
				$GLOBALS['HSDB']['@(\W)xPersonDefault(\W)@'] = '$1"xPersonDefault"$2';
				$GLOBALS['HSDB']['@(\W)xSubscriptions(\W)@'] = '$1"xSubscriptions"$2';
				$GLOBALS['HSDB']['@(\W)iLastReadCount(\W)@'] = '$1"iLastReadCount"$2';
				$GLOBALS['HSDB']['@(\W)sResponseTitle(\W)@'] = '$1"sResponseTitle"$2';
				$GLOBALS['HSDB']['@(\W)xPersonPhotoId(\W)@'] = '$1"xPersonPhotoId"$2';
				$GLOBALS['HSDB']['@(\W)xPersonCreator(\W)@'] = '$1"xPersonCreator"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTDateAdded(\W)@'] = '$1"dtGMTDateAdded"$2';
				$GLOBALS['HSDB']['@(\W)fDefaultTTOpen(\W)@'] = '$1"fDefaultTTOpen"$2';
				$GLOBALS['HSDB']['@(\W)xMergedRequest(\W)@'] = '$1"xMergedRequest"$2';
				$GLOBALS['HSDB']['@(\W)iDecimalPlaces(\W)@'] = '$1"iDecimalPlaces"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTPerformed(\W)@'] = '$1"dtGMTPerformed"$2';
				$GLOBALS['HSDB']['@(\W)tDisplayForums(\W)@'] = '$1"tDisplayForums"$2';
				$GLOBALS['HSDB']['@(\W)fModuleReports(\W)@'] = '$1"fModuleReports"$2';
				$GLOBALS['HSDB']['@(\W)sCategoryGroup(\W)@'] = '$1"sCategoryGroup"$2';
				$GLOBALS['HSDB']['@(\W)fCanManageSpam(\W)@'] = '$1"fCanManageSpam"$2';
				$GLOBALS['HSDB']['@(\W)iTimerSeconds(\W)@'] = '$1"iTimerSeconds"$2';			//13
				$GLOBALS['HSDB']['@(\W)sReportingTag(\W)@'] = '$1"sReportingTag"$2';
				$GLOBALS['HSDB']['@(\W)fNotifyEmail2(\W)@'] = '$1"fNotifyEmail2"$2';
				$GLOBALS['HSDB']['@(\W)xReportingTag(\W)@'] = '$1"xReportingTag"$2';
				$GLOBALS['HSDB']['@(\W)sFileMimeType(\W)@'] = '$1"sFileMimeType"$2';
				$GLOBALS['HSDB']['@(\W)fAutoResponse(\W)@'] = '$1"fAutoResponse"$2';
				$GLOBALS['HSDB']['@(\W)tAutoResponse(\W)@'] = '$1"tAutoResponse"$2';
				$GLOBALS['HSDB']['@(\W)tEmailHeaders(\W)@'] = '$1"tEmailHeaders"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTReminder(\W)@'] = '$1"dtGMTReminder"$2';
				$GLOBALS['HSDB']['@(\W)fAutoAssignTo(\W)@'] = '$1"fAutoAssignTo"$2';
				$GLOBALS['HSDB']['@(\W)HS_Mail_Rules(\W)@'] = '$1"HS_Mail_Rules"$2';
				$GLOBALS['HSDB']['@(\W)sSMTPSettings(\W)@'] = '$1"sSMTPSettings"$2';
				$GLOBALS['HSDB']['@(\W)sFileLocation(\W)@'] = '$1"sFileLocation"$2';
				$GLOBALS['HSDB']['@(\W)xPersonStatus(\W)@'] = '$1"xPersonStatus"$2';
				$GLOBALS['HSDB']['@(\W)fModuleKbPriv(\W)@'] = '$1"fModuleKbPriv"$2';
				$GLOBALS['HSDB']['@(\W)sPasswordHash(\W)@'] = '$1"sPasswordHash"$2';
				$GLOBALS['HSDB']['@(\W)HS_Documents(\W)@'] = '$1"HS_Documents"$2';				//12
				$GLOBALS['HSDB']['@(\W)iLastReplyBy(\W)@'] = '$1"iLastReplyBy"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTTrashed(\W)@'] = '$1"dtGMTTrashed"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTExpires(\W)@'] = '$1"dtGMTExpires"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTCreated(\W)@'] = '$1"dtGMTCreated"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTChanged(\W)@'] = '$1"dtGMTChanged"$2';
				$GLOBALS['HSDB']['@(\W)HS_Responses(\W)@'] = '$1"HS_Responses"$2';
				$GLOBALS['HSDB']['@(\W)xCustomField(\W)@'] = '$1"xCustomField"$2';
				$GLOBALS['HSDB']['@(\W)xOpenedViaId(\W)@'] = '$1"xOpenedViaId"$2';
				$GLOBALS['HSDB']['@(\W)xKnownUserId(\W)@'] = '$1"xKnownUserId"$2';
				$GLOBALS['HSDB']['@(\W)fEmailUpdate(\W)@'] = '$1"fEmailUpdate"$2';
				$GLOBALS['HSDB']['@(\W)sDescription(\W)@'] = '$1"sDescription"$2';
				$GLOBALS['HSDB']['@(\W)sChapterName(\W)@'] = '$1"sChapterName"$2';
				$GLOBALS['HSDB']['@(\W)tDescription(\W)@'] = '$1"tDescription"$2';
				$GLOBALS['HSDB']['@(\W)HS_Mailboxes(\W)@'] = '$1"HS_Mailboxes"$2';
				$GLOBALS['HSDB']['@(\W)xRelatedPage(\W)@'] = '$1"xRelatedPage"$2';
				$GLOBALS['HSDB']['@(\W)fNotifyEmail(\W)@'] = '$1"fNotifyEmail"$2';
				$GLOBALS['HSDB']['@(\W)fHideWysiwyg(\W)@'] = '$1"fHideWysiwyg"$2';
				$GLOBALS['HSDB']['@(\W)sRequestHash(\W)@'] = '$1"sRequestHash"$2';
				$GLOBALS['HSDB']['@(\W)HS_Sessions2(\W)@'] = '$1"HS_Sessions2"$2';
				$GLOBALS['HSDB']['@(\W)fReturnToReq(\W)@'] = '$1"fReturnToReq"$2';
				$GLOBALS['HSDB']['@(\W)iResultCount(\W)@'] = '$1"iResultCount"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTOccured(\W)@'] = '$1"dtGMTOccured"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTEntered(\W)@'] = '$1"dtGMTEntered"$2';
				$GLOBALS['HSDB']['@(\W)fShowWelcome(\W)@'] = '$1"fShowWelcome"$2';
				$GLOBALS['HSDB']['@(\W)iCachedCount(\W)@'] = '$1"iCachedCount"$2';
				$GLOBALS['HSDB']['@(\W)sPortalPhone(\W)@'] = '$1"sPortalPhone"$2';
				$GLOBALS['HSDB']['@(\W)fCanManageKB(\W)@'] = '$1"fCanManageKB"$2';
				$GLOBALS['HSDB']['@(\W)sTriggerName(\W)@'] = '$1"sTriggerName"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTOpened(\W)@'] = '$1"dtGMTOpened"$2';				//11
				$GLOBALS['HSDB']['@(\W)xDocumentId(\W)@'] = '$1"xDocumentId"$2';
				$GLOBALS['HSDB']['@(\W)tModerators(\W)@'] = '$1"tModerators"$2';
				$GLOBALS['HSDB']['@(\W)sReplyEmail(\W)@'] = '$1"sReplyEmail"$2';
				$GLOBALS['HSDB']['@(\W)lrgTextRows(\W)@'] = '$1"lrgTextRows"$2';
				$GLOBALS['HSDB']['@(\W)sFilterName(\W)@'] = '$1"sFilterName"$2';
				$GLOBALS['HSDB']['@(\W)xSMSService(\W)@'] = '$1"xSMSService"$2';
				$GLOBALS['HSDB']['@(\W)dtErrorDate(\W)@'] = '$1"dtErrorDate"$2';
				$GLOBALS['HSDB']['@(\W)HS_Reminder(\W)@'] = '$1"HS_Reminder"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTClosed(\W)@'] = '$1"dtGMTClosed"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTPosted(\W)@'] = '$1"dtGMTPosted"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTChange(\W)@'] = '$1"dtGMTChange"$2';
				$GLOBALS['HSDB']['@(\W)iNotHelpful(\W)@'] = '$1"iNotHelpful"$2';
				$GLOBALS['HSDB']['@(\W)sPrefixType(\W)@'] = '$1"sPrefixType"$2';
				$GLOBALS['HSDB']['@(\W)HS_Category(\W)@'] = '$1"HS_Category"$2';
				$GLOBALS['HSDB']['@(\W)HS_Settings(\W)@'] = '$1"HS_Settings"$2';
				$GLOBALS['HSDB']['@(\W)sPersonList(\W)@'] = '$1"sPersonList"$2';
				$GLOBALS['HSDB']['@(\W)HS_KB_Books(\W)@'] = '$1"HS_KB_Books"$2';
				$GLOBALS['HSDB']['@(\W)HS_KB_Pages(\W)@'] = '$1"HS_KB_Pages"$2';
				$GLOBALS['HSDB']['@(\W)HS_luStatus(\W)@'] = '$1"HS_luStatus"$2';
				$GLOBALS['HSDB']['@(\W)fHideImages(\W)@'] = '$1"fHideImages"$2';
				$GLOBALS['HSDB']['@(\W)fNoteIsHTML(\W)@'] = '$1"fNoteIsHTML"$2';
				$GLOBALS['HSDB']['@(\W)sHTMLEditor(\W)@'] = '$1"sHTMLEditor"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTPushed(\W)@'] = '$1"dtGMTPushed"$2';
				$GLOBALS['HSDB']['@(\W)sReturnedID(\W)@'] = '$1"sReturnedID"$2';
				$GLOBALS['HSDB']['@(\W)sSearchType(\W)@'] = '$1"sSearchType"$2';
				$GLOBALS['HSDB']['@(\W)xStuckEmail(\W)@'] = '$1"xStuckEmail"$2';
				$GLOBALS['HSDB']['@(\W)fCacheNever(\W)@'] = '$1"fCacheNever"$2';
				$GLOBALS['HSDB']['@(\W)sPortalName(\W)@'] = '$1"sPortalName"$2';
				$GLOBALS['HSDB']['@(\W)tDisplayKBs(\W)@'] = '$1"tDisplayKBs"$2';
				$GLOBALS['HSDB']['@(\W)sPortalPath(\W)@'] = '$1"sPortalPath"$2';
				$GLOBALS['HSDB']['@(\W)tDisplayCfs(\W)@'] = '$1"tDisplayCfs"$2';
				$GLOBALS['HSDB']['@(\W)sFilterView(\W)@'] = '$1"sFilterView"$2';
				$GLOBALS['HSDB']['@(\W)fDisplayTop(\W)@'] = '$1"fDisplayTop"$2';
				$GLOBALS['HSDB']['@(\W)HS_Triggers(\W)@'] = '$1"HS_Triggers"$2';
				$GLOBALS['HSDB']['@(\W)tTriggerDef(\W)@'] = '$1"tTriggerDef"$2';
				$GLOBALS['HSDB']['@(\W)dtCreatedOn(\W)@'] = '$1"dtCreatedOn"$2';
				$GLOBALS['HSDB']['@(\W)dtUpdatedOn(\W)@'] = '$1"dtUpdatedOn"$2';
				$GLOBALS['HSDB']['@(\W)HS_Tags_Map(\W)@'] = '$1"HS_Tags_Map"$2';
				$GLOBALS['HSDB']['@(\W)dtDateAdded(\W)@'] = '$1"dtDateAdded"$2';
				$GLOBALS['HSDB']['@(\W)tFilterDef(\W)@'] = '$1"tFilterDef"$2';					//10
				$GLOBALS['HSDB']['@(\W)HS_Filters(\W)@'] = '$1"HS_Filters"$2';
				$GLOBALS['HSDB']['@(\W)isRequired(\W)@'] = '$1"isRequired"$2';
				$GLOBALS['HSDB']['@(\W)sForumName(\W)@'] = '$1"sForumName"$2';
				$GLOBALS['HSDB']['@(\W)fHighlight(\W)@'] = '$1"fHighlight"$2';
				$GLOBALS['HSDB']['@(\W)sFirstName(\W)@'] = '$1"sFirstName"$2';
				$GLOBALS['HSDB']['@(\W)HS_Request(\W)@'] = '$1"HS_Request"$2';
				$GLOBALS['HSDB']['@(\W)fOpenedVia(\W)@'] = '$1"fOpenedVia"$2';
				$GLOBALS['HSDB']['@(\W)sReplyName(\W)@'] = '$1"sReplyName"$2';
				$GLOBALS['HSDB']['@(\W)fNotifySMS(\W)@'] = '$1"fNotifySMS"$2';
				$GLOBALS['HSDB']['@(\W)tSignature(\W)@'] = '$1"tSignature"$2';
				$GLOBALS['HSDB']['@(\W)sTotalSize(\W)@'] = '$1"sTotalSize"$2';
				$GLOBALS['HSDB']['@(\W)tWorkspace(\W)@'] = '$1"tWorkspace"$2';
				$GLOBALS['HSDB']['@(\W)fShowCount(\W)@'] = '$1"fShowCount"$2';		
				$GLOBALS['HSDB']['@(\W)dtGMTSaved(\W)@'] = '$1"dtGMTSaved"$2';
				$GLOBALS['HSDB']['@(\W)sEmailFrom(\W)@'] = '$1"sEmailFrom"$2';
				$GLOBALS['HSDB']['@(\W)sEmailDate(\W)@'] = '$1"sEmailDate"$2';
				$GLOBALS['HSDB']['@(\W)tPortalMsg(\W)@'] = '$1"tPortalMsg"$2';
				$GLOBALS['HSDB']['@(\W)fViewInbox(\W)@'] = '$1"fViewInbox"$2';
				$GLOBALS['HSDB']['@(\W)sBookName(\W)@'] = '$1"sBookName"$2';					//9
				$GLOBALS['HSDB']['@(\W)sPageName(\W)@'] = '$1"sPageName"$2';
				$GLOBALS['HSDB']['@(\W)expireref(\W)@'] = '$1"expireref"$2';
				$GLOBALS['HSDB']['@(\W)xCategory(\W)@'] = '$1"xCategory"$2';
				$GLOBALS['HSDB']['@(\W)fAppendix(\W)@'] = '$1"fAppendix"$2';
				$GLOBALS['HSDB']['@(\W)sFromSize(\W)@'] = '$1"sFromSize"$2';
				$GLOBALS['HSDB']['@(\W)fDownload(\W)@'] = '$1"fDownload"$2';
				$GLOBALS['HSDB']['@(\W)tResponse(\W)@'] = '$1"tResponse"$2';
				$GLOBALS['HSDB']['@(\W)fieldType(\W)@'] = '$1"fieldType"$2';
				$GLOBALS['HSDB']['@(\W)HS_Errors(\W)@'] = '$1"HS_Errors"$2';
				$GLOBALS['HSDB']['@(\W)xReminder(\W)@'] = '$1"xReminder"$2';
				$GLOBALS['HSDB']['@(\W)sPassword(\W)@'] = '$1"sPassword"$2';
				$GLOBALS['HSDB']['@(\W)sHostname(\W)@'] = '$1"sHostname"$2';
				$GLOBALS['HSDB']['@(\W)sSecurity(\W)@'] = '$1"sSecurity"$2';
				$GLOBALS['HSDB']['@(\W)sUsername(\W)@'] = '$1"sUsername"$2';
				$GLOBALS['HSDB']['@(\W)iMsgCount(\W)@'] = '$1"iMsgCount"$2';
				$GLOBALS['HSDB']['@(\W)HS_Forums(\W)@'] = '$1"HS_Forums"$2';
				$GLOBALS['HSDB']['@(\W)sLastName(\W)@'] = '$1"sLastName"$2';
				$GLOBALS['HSDB']['@(\W)fieldName(\W)@'] = '$1"fieldName"$2';
				$GLOBALS['HSDB']['@(\W)sCategory(\W)@'] = '$1"sCategory"$2';
				$GLOBALS['HSDB']['@(\W)sFilename(\W)@'] = '$1"sFilename"$2';
				$GLOBALS['HSDB']['@(\W)HS_Person(\W)@'] = '$1"HS_Person"$2';
				$GLOBALS['HSDB']['@(\W)xResponse(\W)@'] = '$1"xResponse"$2';
				$GLOBALS['HSDB']['@(\W)blobPhoto(\W)@'] = '$1"blobPhoto"$2';
				$GLOBALS['HSDB']['@(\W)tReminder(\W)@'] = '$1"tReminder"$2';
				$GLOBALS['HSDB']['@(\W)listItems(\W)@'] = '$1"listItems"$2';
				$GLOBALS['HSDB']['@(\W)fUserType(\W)@'] = '$1"fUserType"$2';
				$GLOBALS['HSDB']['@(\W)sShortcut(\W)@'] = '$1"sShortcut"$2';
				$GLOBALS['HSDB']['@(\W)dtGMTDate(\W)@'] = '$1"dtGMTDate"$2';
				$GLOBALS['HSDB']['@(\W)xMailRule(\W)@'] = '$1"xMailRule"$2';
				$GLOBALS['HSDB']['@(\W)sRuleName(\W)@'] = '$1"sRuleName"$2';
				$GLOBALS['HSDB']['@(\W)xAutoRule(\W)@'] = '$1"xAutoRule"$2';
				$GLOBALS['HSDB']['@(\W)timetrack(\W)@'] = '$1"timetrack"$2';
				$GLOBALS['HSDB']['@(\W)sFromPage(\W)@'] = '$1"sFromPage"$2';
				$GLOBALS['HSDB']['@(\W)sCacheKey(\W)@'] = '$1"sCacheKey"$2';
				$GLOBALS['HSDB']['@(\W)sPushedTo(\W)@'] = '$1"sPushedTo"$2';
				$GLOBALS['HSDB']['@(\W)fCanMerge(\W)@'] = '$1"fCanMerge"$2';
				$GLOBALS['HSDB']['@(\W)fBillable(\W)@'] = '$1"fBillable"$2';
				$GLOBALS['HSDB']['@(\W)isPublic(\W)@'] = '$1"isPublic"$2';							//8
				$GLOBALS['HSDB']['@(\W)sMailbox(\W)@'] = '$1"sMailbox"$2';
				$GLOBALS['HSDB']['@(\W)modified(\W)@'] = '$1"modified"$2';
				$GLOBALS['HSDB']['@(\W)sessdata(\W)@'] = '$1"sessdata"$2';
				$GLOBALS['HSDB']['@(\W)HS_luSMS(\W)@'] = '$1"HS_luSMS"$2';
				$GLOBALS['HSDB']['@(\W)sBrowser(\W)@'] = '$1"sBrowser"$2';
				$GLOBALS['HSDB']['@(\W)fPrivate(\W)@'] = '$1"fPrivate"$2';
				$GLOBALS['HSDB']['@(\W)fInitial(\W)@'] = '$1"fInitial"$2';
				$GLOBALS['HSDB']['@(\W)blobFile(\W)@'] = '$1"blobFile"$2';
				$GLOBALS['HSDB']['@(\W)xTopicId(\W)@'] = '$1"xTopicId"$2';
				$GLOBALS['HSDB']['@(\W)sSetting(\W)@'] = '$1"sSetting"$2';
				$GLOBALS['HSDB']['@(\W)iHelpful(\W)@'] = '$1"iHelpful"$2';
				$GLOBALS['HSDB']['@(\W)xForumId(\W)@'] = '$1"xForumId"$2';
				$GLOBALS['HSDB']['@(\W)xMailbox(\W)@'] = '$1"xMailbox"$2';
				$GLOBALS['HSDB']['@(\W)xChapter(\W)@'] = '$1"xChapter"$2';
				$GLOBALS['HSDB']['@(\W)fDeleted(\W)@'] = '$1"fDeleted"$2';
				$GLOBALS['HSDB']['@(\W)xRequest(\W)@'] = '$1"xRequest"$2';
				$GLOBALS['HSDB']['@(\W)iSeconds(\W)@'] = '$1"iSeconds"$2';
				$GLOBALS['HSDB']['@(\W)sMsgSize(\W)@'] = '$1"sMsgSize"$2';
				$GLOBALS['HSDB']['@(\W)sTxtSize(\W)@'] = '$1"sTxtSize"$2';
				$GLOBALS['HSDB']['@(\W)sAddress(\W)@'] = '$1"sAddress"$2';
				$GLOBALS['HSDB']['@(\W)tEditors(\W)@'] = '$1"tEditors"$2';
				$GLOBALS['HSDB']['@(\W)tRuleDef(\W)@'] = '$1"tRuleDef"$2';
				$GLOBALS['HSDB']['@(\W)sAjaxUrl(\W)@'] = '$1"sAjaxUrl"$2';
				$GLOBALS['HSDB']['@(\W)tComment(\W)@'] = '$1"tComment"$2';
				$GLOBALS['HSDB']['@(\W)dtExpire(\W)@'] = '$1"dtExpire"$2';
				$GLOBALS['HSDB']['@(\W)sDetails(\W)@'] = '$1"sDetails"$2';
				$GLOBALS['HSDB']['@(\W)xContact(\W)@'] = '$1"xContact"$2';
				$GLOBALS['HSDB']['@(\W)dtChange(\W)@'] = '$1"dtChange"$2';
				$GLOBALS['HSDB']['@(\W)sLogItem(\W)@'] = '$1"sLogItem"$2';
				$GLOBALS['HSDB']['@(\W)xTrigger(\W)@'] = '$1"xTrigger"$2';
				$GLOBALS['HSDB']['@(\W)xAttempt(\W)@'] = '$1"xAttempt"$2';
				$GLOBALS['HSDB']['@(\W)xFilter(\W)@'] = '$1"xFilter"$2';							//7
				$GLOBALS['HSDB']['@(\W)xPostId(\W)@'] = '$1"xPostId"$2';
				$GLOBALS['HSDB']['@(\W)sesskey(\W)@'] = '$1"sesskey"$2';
				$GLOBALS['HSDB']['@(\W)created(\W)@'] = '$1"created"$2';
				$GLOBALS['HSDB']['@(\W)sFolder(\W)@'] = '$1"sFolder"$2';
				$GLOBALS['HSDB']['@(\W)fClosed(\W)@'] = '$1"fClosed"$2';
				$GLOBALS['HSDB']['@(\W)xStatus(\W)@'] = '$1"xStatus"$2';
				$GLOBALS['HSDB']['@(\W)fSticky(\W)@'] = '$1"fSticky"$2';
				$GLOBALS['HSDB']['@(\W)fHidden(\W)@'] = '$1"fHidden"$2';
				$GLOBALS['HSDB']['@(\W)xPerson(\W)@'] = '$1"xPerson"$2';
				$GLOBALS['HSDB']['@(\W)xTimeId(\W)@'] = '$1"xTimeId"$2';
				$GLOBALS['HSDB']['@(\W)fUrgent(\W)@'] = '$1"fUrgent"$2';
				$GLOBALS['HSDB']['@(\W)sEmail2(\W)@'] = '$1"sEmail2"$2';
				$GLOBALS['HSDB']['@(\W)xErrors(\W)@'] = '$1"xErrors"$2';
				$GLOBALS['HSDB']['@(\W)fGlobal(\W)@'] = '$1"fGlobal"$2';
				$GLOBALS['HSDB']['@(\W)sStatus(\W)@'] = '$1"sStatus"$2';
				$GLOBALS['HSDB']['@(\W)fPublic(\W)@'] = '$1"fPublic"$2';
				$GLOBALS['HSDB']['@(\W)sUserId(\W)@'] = '$1"sUserId"$2';
				$GLOBALS['HSDB']['@(\W)xPushed(\W)@'] = '$1"xPushed"$2';
				$GLOBALS['HSDB']['@(\W)xSearch(\W)@'] = '$1"xSearch"$2';
				$GLOBALS['HSDB']['@(\W)sSearch(\W)@'] = '$1"sSearch"$2';
				$GLOBALS['HSDB']['@(\W)xPortal(\W)@'] = '$1"xPortal"$2';
				$GLOBALS['HSDB']['@(\W)sSeries(\W)@'] = '$1"sSeries"$2';
				$GLOBALS['HSDB']['@(\W)HS_Tags(\W)@'] = '$1"HS_Tags"$2';
				$GLOBALS['HSDB']['@(\W)xTagMap(\W)@'] = '$1"xTagMap"$2';
				$GLOBALS['HSDB']['@(\W)xReport(\W)@'] = '$1"xReport"$2';
				$GLOBALS['HSDB']['@(\W)sReport(\W)@'] = '$1"sReport"$2';
				$GLOBALS['HSDB']['@(\W)dtRunAt(\W)@'] = '$1"dtRunAt"$2';
				$GLOBALS['HSDB']['@(\W)sTitle(\W)@'] = '$1"sTitle"$2';								//6
				$GLOBALS['HSDB']['@(\W)fTrash(\W)@'] = '$1"fTrash"$2';
				$GLOBALS['HSDB']['@(\W)expiry(\W)@'] = '$1"expiry"$2';
				$GLOBALS['HSDB']['@(\W)sFname(\W)@'] = '$1"sFname"$2';
				$GLOBALS['HSDB']['@(\W)sTopic(\W)@'] = '$1"sTopic"$2';
				$GLOBALS['HSDB']['@(\W)sEmail(\W)@'] = '$1"sEmail"$2';
				$GLOBALS['HSDB']['@(\W)sPhone(\W)@'] = '$1"sPhone"$2';
				$GLOBALS['HSDB']['@(\W)fOrder(\W)@'] = '$1"fOrder"$2';
				$GLOBALS['HSDB']['@(\W)iCount(\W)@'] = '$1"iCount"$2';
				$GLOBALS['HSDB']['@(\W)iOrder(\W)@'] = '$1"iOrder"$2';
				$GLOBALS['HSDB']['@(\W)tValue(\W)@'] = '$1"tValue"$2';
				$GLOBALS['HSDB']['@(\W)sLname(\W)@'] = '$1"sLname"$2';
				$GLOBALS['HSDB']['@(\W)sLabel(\W)@'] = '$1"sLabel"$2';
				$GLOBALS['HSDB']['@(\W)sRegex(\W)@'] = '$1"sRegex"$2';
				$GLOBALS['HSDB']['@(\W)xDraft(\W)@'] = '$1"xDraft"$2';
				$GLOBALS['HSDB']['@(\W)xEvent(\W)@'] = '$1"xEvent"$2';
				$GLOBALS['HSDB']['@(\W)xLogin(\W)@'] = '$1"xLogin"$2';
				$GLOBALS['HSDB']['@(\W)xGroup(\W)@'] = '$1"xGroup"$2';
				$GLOBALS['HSDB']['@(\W)sGroup(\W)@'] = '$1"sGroup"$2';
				$GLOBALS['HSDB']['@(\W)fValid(\W)@'] = '$1"fValid"$2';
				$GLOBALS['HSDB']['@(\W)xReset(\W)@'] = '$1"xReset"$2';
				$GLOBALS['HSDB']['@(\W)sToken(\W)@'] = '$1"sToken"$2';
				$GLOBALS['HSDB']['@(\W)sFile(\W)@'] = '$1"sFile"$2';								//5
				$GLOBALS['HSDB']['@(\W)sType(\W)@'] = '$1"sType"$2';
				$GLOBALS['HSDB']['@(\W)tData(\W)@'] = '$1"tData"$2';
				$GLOBALS['HSDB']['@(\W)sName(\W)@'] = '$1"sName"$2';
				$GLOBALS['HSDB']['@(\W)tNote(\W)@'] = '$1"tNote"$2';
				$GLOBALS['HSDB']['@(\W)sDesc(\W)@'] = '$1"sDesc"$2';
				$GLOBALS['HSDB']['@(\W)sLine(\W)@'] = '$1"sLine"$2';
				$GLOBALS['HSDB']['@(\W)sPort(\W)@'] = '$1"sPort"$2';
				$GLOBALS['HSDB']['@(\W)tPage(\W)@'] = '$1"tPage"$2';
				$GLOBALS['HSDB']['@(\W)xBook(\W)@'] = '$1"xBook"$2';
				$GLOBALS['HSDB']['@(\W)tPost(\W)@'] = '$1"tPost"$2';
				$GLOBALS['HSDB']['@(\W)fOpen(\W)@'] = '$1"fOpen"$2';
				$GLOBALS['HSDB']['@(\W)xPage(\W)@'] = '$1"xPage"$2';
				$GLOBALS['HSDB']['@(\W)sWord(\W)@'] = '$1"sWord"$2';
				$GLOBALS['HSDB']['@(\W)fSpam(\W)@'] = '$1"fSpam"$2';
				$GLOBALS['HSDB']['@(\W)sPage(\W)@'] = '$1"sPage"$2';
				$GLOBALS['HSDB']['@(\W)sHost(\W)@'] = '$1"sHost"$2';
				$GLOBALS['HSDB']['@(\W)fType(\W)@'] = '$1"fType"$2';
				$GLOBALS['HSDB']['@(\W)sShow(\W)@'] = '$1"sShow"$2';
				$GLOBALS['HSDB']['@(\W)dTime(\W)@'] = '$1"dTime"$2';
				$GLOBALS['HSDB']['@(\W)tLog(\W)@'] = '$1"tLog"$2';									//4
				$GLOBALS['HSDB']['@(\W)sURL(\W)@'] = '$1"sURL"$2';
				$GLOBALS['HSDB']['@(\W)fTop(\W)@'] = '$1"fTop"$2';
				$GLOBALS['HSDB']['@(\W)sSMS(\W)@'] = '$1"sSMS"$2';
				$GLOBALS['HSDB']['@(\W)xTag(\W)@'] = '$1"xTag"$2';
				$GLOBALS['HSDB']['@(\W)sTag(\W)@'] = '$1"sTag"$2';
				$GLOBALS['HSDB']['@(\W)sCID(\W)@'] = '$1"sCID"$2';
				$GLOBALS['HSDB']['@(\W)sOS(\W)@'] = '$1"sOS"$2';									//3
				$GLOBALS['HSDB']['@(\W)sIP(\W)@'] = '$1"sIP"$2';
				$GLOBALS['HSDB']['@(\W)xID(\W)@'] = '$1"xID"$2';
			}
		
			$sql = ' '.$sql.' ';	//Needs this space to do regex correctly. Won't match pattern if last field has no space after.
			
			foreach($GLOBALS['HSDB'] AS $k=>$v){
				$sql = preg_replace($k, $v, $sql); //rebuilds SQL and passes back by ref to adodb function Execute	
			} //echo $sql."\n";
		}	
	}	

}

?>
